searchNodes=[{"type":"module","title":"Cldr.Unit.DDL","doc":"Functions to return SQL DDL commands that support the creation and deletion of the cldr_unit database type and associated aggregate functions.","ref":"Cldr.Unit.DDL.html"},{"type":"function","title":"Cldr.Unit.DDL.create_cldr_unit/1","doc":"Returns the SQL string which when executed will define the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#create_cldr_unit/1"},{"type":"function","title":"Cldr.Unit.DDL.define_aggregate_functions/1","doc":"Returns the SQL string which when executed will define aggregate functions for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#define_aggregate_functions/1"},{"type":"function","title":"Cldr.Unit.DDL.drop_aggregate_functions/1","doc":"Returns the SQL string which when executed will drop the aggregate functions for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#drop_aggregate_functions/1"},{"type":"function","title":"Cldr.Unit.DDL.drop_cldr_unit/1","doc":"Returns the SQL string which when executed will drop the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#drop_cldr_unit/1"},{"type":"function","title":"Cldr.Unit.DDL.execute/1","doc":"Returns a string that will Ecto execute a single SQL command. Arguments sql is a single SQL command Example iex&gt; Money.DDL . execute &quot;SELECT name FROM customers;&quot; &quot;execute &quot; SELECT name FROM customers ; &quot;&quot;","ref":"Cldr.Unit.DDL.html#execute/1"},{"type":"function","title":"Cldr.Unit.DDL.execute_each/1","doc":"Returns a string that will Ecto execute each SQL command. Arguments sql is a string of SQL commands that are separated by three newlines (&quot;\\n&quot;), that is to say two blank lines between commands in the file. Example iex&gt; Money.DDL . execute &quot; SELECT name FROM customers ; SELECT id FROM orders;&quot; &quot;execute &quot; &quot;&quot; SELECT name FROM customers; SELECT id FROM orders; &quot;&quot;&quot;&quot;","ref":"Cldr.Unit.DDL.html#execute_each/1"},{"type":"module","title":"Cldr.Unit.Ecto.Composite.Type","doc":"Implements the Ecto.Type behaviour for a user-defined Postgres composite type called :cldr_unit . This is the preferred option for Postgres database since the serialized unit value is stored as a decimal number,","ref":"Cldr.Unit.Ecto.Composite.Type.html"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.blank?/1","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#blank?/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.cast/1","doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Cldr.Unit.Ecto.Composite.Type.html#cast/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.dump/1","doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Cldr.Unit.Ecto.Composite.Type.html#dump/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.embed_as/1","doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Cldr.Unit.Ecto.Composite.Type.html#embed_as/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.equal?/2","doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Cldr.Unit.Ecto.Composite.Type.html#equal?/2"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.load/1","doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Cldr.Unit.Ecto.Composite.Type.html#load/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.type/0","doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Cldr.Unit.Ecto.Composite.Type.html#type/0"},{"type":"module","title":"Cldr.Unit.Ecto.Map.Type","doc":"Implements Ecto.Type behaviour for Cldr.Unit , where the underlying schema type is a map. This is the required option for databases such as MySQL that do not support composite types. In order to preserve precision, the value is serialized as a string since the JSON representation of a numeric value is either an integer or a float. Decimal.to_string/1 is not guaranteed to produce a string that will round-trip convert back to the identical number. However given enough precision in the Decimal context then round trip conversion should be expected. The default precision in the context is 28 digits.","ref":"Cldr.Unit.Ecto.Map.Type.html"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.cast/1","doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Cldr.Unit.Ecto.Map.Type.html#cast/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.dump/1","doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Cldr.Unit.Ecto.Map.Type.html#dump/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.embed_as/1","doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Cldr.Unit.Ecto.Map.Type.html#embed_as/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.equal?/2","doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Cldr.Unit.Ecto.Map.Type.html#equal?/2"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.load/1","doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Cldr.Unit.Ecto.Map.Type.html#load/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.type/0","doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Cldr.Unit.Ecto.Map.Type.html#type/0"},{"type":"module","title":"Cldr.UnitWithUsage.Ecto.Composite.Type","doc":"Implements the Ecto.Type behaviour for a user-defined Postgres composite type called :cldr_unit . This is the preferred option for Postgres database since the serialized unit value is stored as a decimal number,","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.blank?/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#blank?/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.cast/1","doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#cast/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.dump/1","doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#dump/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.embed_as/1","doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#embed_as/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.equal?/2","doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#equal?/2"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.load/1","doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#load/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.type/0","doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#type/0"},{"type":"module","title":"Cldr.UnitWithUsage.Ecto.Map.Type","doc":"Implements Ecto.Type behaviour for Cldr.Unit , where the underlying schema type is a map. This is the required option for databases such as MySQL that do not support composite types. In order to preserve precision, the value is serialized as a string since the JSON representation of a numeric value is either an integer or a float. Decimal.to_string/1 is not guaranteed to produce a string that will round-trip convert back to the identical number. However given enough precision in the Decimal context then round trip conversion should be expected. The default precision in the context is 28 digits.","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.cast/1","doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#cast/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.dump/1","doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#dump/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.embed_as/1","doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#embed_as/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.equal?/2","doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#equal?/2"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.load/1","doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#load/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.type/0","doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#type/0"},{"type":"task","title":"Mix.Tasks.Units.Gen.Postgres.AggregateFunctions","doc":"Generates a migration to add a aggregation functions to Postgres for the :cldr_unit type This release includes only the sum aggregattion function.","ref":"Mix.Tasks.Units.Gen.Postgres.AggregateFunctions.html"},{"type":"task","title":"Mix.Tasks.Units.Gen.Postgres.CldrUnitsMigration","doc":"Generates a migration to add a composite type called :cldr_unit to a Postgres database. The :cldr_unit type created is a composite type and therefore may not be supported in other databases.","ref":"Mix.Tasks.Units.Gen.Postgres.CldrUnitsMigration.html"},{"type":"extras","title":"Introduction to Cldr Units SQL","doc":"ex_cldr_units_sql implements a set of functions to store and retrieve data structured as a Cldr.Unit.t() type that represents a unit of measure and a value. See ex_cldr_units for details of using Cldr.Unit . Note that ex_cldr_units_sql depends on ex_cldr_units .","ref":"readme.html"},{"type":"extras","title":"Introduction to Cldr Units SQL - Prerequisities","doc":"ex_cldr_units_sql is supported on Elixir 1.11 and later only. Make sure the Ecto type and the database type match! It's important that the Ecto type Cldr.Unit.Ecto.Composite.Type is matched with the correct database type in the migration: :cldr_unit or :cldr_unit_with_usage . Similarly Cldr.Unit.Ecto.Map.Type must be matched with the database type :map in the migration.","ref":"readme.html#prerequisities"},{"type":"extras","title":"Introduction to Cldr Units SQL - Serializing to a Postgres database with Ecto","doc":"ex_cldr_units_sql provides custom Ecto data types and two custom Postgres data types to provide serialization of Cldr.Unit.t types without losing precision whilst also maintaining the integrity of the {unit, value} relationship. To serialise and retrieve unit types from a database the following steps should be followed: First generate the migration to create the custom type: mix units . gen . postgres . cldr_units_migration * creating priv / repo / migrations * creating priv / repo / migrations / 20161007234652 _add_cldr_unit_type_to_postgres . exs Then migrate the database: mix ecto . migrate 21 : 01 : 29.527 [ info ] == Running 20200517121207 Cldr.Unit.SQL.Repo.Migrations.AddCldrUnitTypeToPostgres . up / 0 forward 21 : 01 : 29.529 [ info ] execute &quot;CREATE TYPE public.cldr_unit AS (unit varchar, value numeric);&quot; 21 : 01 : 29.532 [ info ] execute &quot;CREATE TYPE public.cldr_unit_with_usage AS (unit varchar, value numeric, usage varchar);&quot; 21 : 01 : 29.546 [ info ] == Migrated 20200517121207 in 0.0 s Create your database migration with the new type (don't forget to mix ecto.migrate as well): defmodule Cldr.Unit.Repo.Migrations.CreateProduct do use Ecto.Migration def change do create table ( :products ) do add :weight , :cldr_unit add :length , :cldr_unit_with_usage timestamps ( ) end end end Create your schema using the Cldr.Unit.Ecto.Composite.Type ecto type: defmodule Product do use Ecto.Schema schema &quot;products&quot; do field :weight , Cldr.Unit.Ecto.Composite.Type field :length , Cldr.UnitWithUsage.Ecto.Composite.Type timestamps ( ) end end Insert into the database: iex&gt; Repo . insert % Product { weight : Cldr.Unit . new ( :kilogram , Decimal . new ( 100 ) ) } [ debug ] QUERY OK db = 4.5 ms INSERT INTO &quot;products&quot; ( &quot;value&quot; , &quot;inserted_at&quot; , &quot;updated_at&quot; ) VALUES ( $ 1 , $ 2 , $ 3 ) [ { &quot;meter&quot; , # Decimal &lt; 100 &gt; } , { { 2016 , 10 , 7 } , { 23 , 12 , 13 , 0 } } , { { 2016 , 10 , 7 } , { 23 , 12 , 13 , 0 } } ] Retrieve from the database: iex&gt; Repo . all Product [ debug ] QUERY OK source = &quot;products&quot; db = 5.3 ms decode = 0.1 ms queue = 0.1 ms SELECT p0 . &quot;amount&quot; , p0 . &quot;inserted_at&quot; , p0 . &quot;updated_at&quot; FROM &quot;products&quot; AS p0 [ ] [ % Product { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;products&quot; &gt; , weight : # Cldr.Unit &lt; :meter , 100 &gt; , inserted_at : ~N[2017-02-21 00:15:40.979576] , updated_at : ~N[2017-02-21 00:15:40.991391] } ]","ref":"readme.html#serializing-to-a-postgres-database-with-ecto"},{"type":"extras","title":"Introduction to Cldr Units SQL - Serializing to a MySQL (or other non-Postgres) database with Ecto","doc":"Since MySQL does not support composite types, the :map type is used which in MySQL is implemented as a JSON column. The currency code and amount are serialised into this column. defmodule Cldr.Unit.Repo.Migrations.CreateProduct do use Ecto.Migration def change do create table ( :products ) do add :weight_map , :map add :length_map , :map timestamps ( ) end end end Create your schema using the Cldr.Unit.Ecto.Map.Type ecto type: defmodule Product do use Ecto.Schema schema &quot;products&quot; do field :weight_map , Cldr.Unit.Ecto.Map.Type field :length_map , Cldr.UnitWithUsage.Ecto.Map.Type timestamps ( ) end end Insert into the database: iex&gt; Repo . insert % Product { weight_map : Cldr.Unit . new! ( :kilogram , 100 ) } [ debug ] QUERY OK db = 25.8 ms INSERT INTO &quot;products&quot; ( &quot;weight_map&quot; , &quot;inserted_at&quot; , &quot;updated_at&quot; ) VALUES ( $ 1 , $ 2 , $ 3 ) RETURNING &quot;id&quot; [ %{ value : &quot;100&quot; , unit : &quot;kilogram&quot; } , { { 2017 , 2 , 21 } , { 0 , 15 , 40 , 979576 } } , { { 2017 , 2 , 21 } , { 0 , 15 , 40 , 991391 } } ] { :ok , % Product { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;products&quot; &gt; , amount : nil , weight_map : # Cldr.Unit &lt; :kilogram , 100 &gt; , id : 3 , inserted_at : ~N[2017-02-21 00:15:40.979576] , updated_at : ~N[2017-02-21 00:15:40.991391] } } Retrieve from the database: iex&gt; Repo . all Product [ debug ] QUERY OK source = &quot;products&quot; db = 16.1 ms decode = 0.1 ms SELECT t0 . &quot;id&quot; , t0 . &quot;weight_map&quot; , t0 . &quot;inserted_at&quot; , t0 . &quot;updated_at&quot; FROM &quot;products&quot; AS t0 [ ] [ % Ledger { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;products&quot; &gt; , weight_map : # Cldr.Unit &lt; :kilogram , 100 &gt; , id : 3 , inserted_at : ~N[2017-02-21 00:15:40.979576] , updated_at : ~N[2017-02-21 00:15:40.991391] } ] Notes: In order to preserve precision of the decimal amount, the amount part of the Cldr.Unit.t() struct is serialised as a string. This is done because JSON serializes numeric values as either integer or float , neither of which would preserve precision of a decimal value. The precision of the serialized string value is affected by the setting of Decimal.get_context . The default is 28 digits which should cater for your requirements. Serializing the amount as a string means that SQL query arithmetic and equality operators will not work as expected. You may find that CAST ing the string value will restore some of that functionality. For example: CAST(JSON_EXTRACT(amount_map, '$.value') AS DECIMAL(20, 8)) AS amount;","ref":"readme.html#serializing-to-a-mysql-or-other-non-postgres-database-with-ecto"},{"type":"extras","title":"Introduction to Cldr Units SQL - Postgres Database functions","doc":"Since the datatype used to store Cldr.Unit in Postgres is a composite type (called :cldr_unit ), the standard aggregation functions like sum and average are not supported and the order_by clause doesn't perform as expected. ex_cldr_units_sql provides mechanisms to provide these functions. Aggregate functions: sum() ex_cldr_unit_sql provides a migration generator which, when migrated to the database with mix ecto.migrate , supports performing sum() aggregation on :cldr_unit types. The steps are: Generate the migration by executing mix units.gen.postgres.aggregate_functions Migrate the database by executing mix ecto.migrate Formulate an Ecto query to use the aggregate function sum() # Formulate the query. Note the required use of the type() # expression which is needed to inform Ecto of the return # type of the function iex&gt; q = Ecto.Query . select Product , [ p ] , type ( sum ( p . weight ) , p . weight ) # Ecto.Query &lt; from p in Product select : type ( sum ( p . weight ) , p . weight ) &gt; iex&gt; Repo . all q [ debug ] QUERY OK source = &quot;products&quot; db = 6.1 ms SELECT sum ( p0 . &quot;weight&quot; ) :: cldr_unit_with_usage FROM &quot;products&quot; AS l0 [ ] [ # Cldr.Unit &lt; :meter , 600 &gt; ] The function Repo.aggregate/3 can also be used. However at least ecto version 3.2.4 is required for this to work correctly for custom ecto types such as :cldr_unit . iex&gt; Repo . aggregate ( Product , :sum , :weight ) # Cldr.Unit &lt; :kilogram , 100 &gt; Note that to preserve the integrity of Cldr.Unit it is not permissible to aggregate units that has different unit types. If you attempt to aggregate unit with different unit types the query will abort and an exception will be raised: iex&gt; Repo . all q [ debug ] QUERY ERROR source = &quot;products&quot; db = 4.5 ms SELECT sum ( p0 . &quot;weight&quot; ) :: cldr_unit_with_usage FROM &quot;products&quot; AS p0 [ ] ** (Postgrex.Error) ERROR 22033 (): Incompatible units. Expected all units to be :kilogram Order_by with cldr_unit type Since :cldr_unit is a composite type, the default order_by results may surprise since the ordering is based upon the type structure, not the unit value. Postgres defines a means to access the components of a composite type and therefore sorting can be done in a more predictable fashion. For example: # In this example we are decomposing the the composite column called # `price` and using the sub-field `value` to perform the ordering. iex&gt; q = from p in Product , select : p . weight , order_by : fragment ( &quot;value(weight)&quot; ) # Ecto.Query &lt; from p in Product , order_by : [ asc : fragment ( &quot;value(weight)&quot; ) ] , select : p . weight &gt; iex&gt; Repo . all q [ debug ] QUERY OK source = &quot;products&quot; db = 2.0 ms SELECT p0 . &quot;weight&quot; FROM &quot;products&quot; AS p0 ORDER BY value ( weight ) [ ] [ # Cldr.Unit &lt; :kilogram , 100 &gt; , # Cldr.Unit &lt; :pound , 200 &gt; , # Cldr.Unit &lt; :pound , 300 &gt; , # Cldr.Unit &lt; :kilogram , 300 &gt; ] Note that the results may still be unexpected. The example above shows the correct ascending ordering by value(weight) however the ordering is not unit aware and therefore mixed units will return a largely meaningless order.","ref":"readme.html#postgres-database-functions"},{"type":"extras","title":"Introduction to Cldr Units SQL - Installation","doc":"ex_cldr_units_sql can be installed by adding ex_cldr_units_sql to your list of dependencies in mix.exs and then executing mix deps.get def deps do [ { :ex_cldr_units_sql , &quot;~&gt; 1.0&quot; } , ... ] end","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - Cldr Units SQL v1.0.0","doc":"This is the changelog for Cldr Units SQL v1.0.0 released on April 28th, 2023. For older changelogs please consult the release tag on GitHub Enhancements Updates to ex_cldr version 2.37.0 which includes data from CLDR release 43 Removes requirement and support for Ratio-based units in line with ex_cldr_units .","ref":"changelog.html#cldr-units-sql-v1-0-0"},{"type":"extras","title":"Changelog - Cldr Units SQL v0.3.1","doc":"This is the changelog for Cldr Units SQL v0.3.1 released on July 9th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Correctly compare two units in the Ecto types. Thanks to @0urobor0s for the PR. Closes #1 Fix dialyzer issues","ref":"changelog.html#cldr-units-sql-v0-3-1"},{"type":"extras","title":"Changelog - Cldr Units SQL v0.3.0","doc":"This is the changelog for Cldr Units SQL v0.3.0 released on June 11th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Fix parsing to be independent of Decimal 1.x or Decimal 2.x","ref":"changelog.html#cldr-units-sql-v0-3-0"},{"type":"extras","title":"Changelog - Cldr Units SQL v0.2.0","doc":"This is the changelog for Cldr Units SQL v0.2.0 released on September 6th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add :unit_with_usage type to serialize units including the usage field. This requires more database storage but is a more complete serialization for round tripping unit data. The type modules are Cldr.UnitWithUsage.Ecto.Composite.Type and Cldr.UnitWithUsage.Ecto.Map.Type .","ref":"changelog.html#cldr-units-sql-v0-2-0"},{"type":"extras","title":"Changelog - Cldr Units SQL v0.1.0","doc":"This is the changelog for Cldr Units SQL released on May 17th, 2020. Enhancements Initial release","ref":"changelog.html#cldr-units-sql-v0-1-0"},{"type":"extras","title":"LICENSE","doc":"","ref":"license.html"},{"type":"extras","title":"LICENSE - License","doc":"Copyright 2020-2023 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license"}]